using System;
using System.ComponentModel ;
using System.Reflection ;
namespace ICustomTypeSample
{
	/// <summary>
	/// Summary description for CustomPropertyDescriptor.
	/// </summary>
	public class CustomPropertyDescriptor : PropertyDescriptor 
	{
		public CustomPropertyDescriptor(string Name , PropertyInfo Pi): base(Name , (System.Attribute[])Pi.GetCustomAttributes(typeof(System.Attribute), true))
		{
			Prop = Pi;
			PropName = Name;
		}
		string PropName = string.Empty ;
		internal PropertyInfo Prop ;
		public override bool Equals(object obj)
		{
			return false;
		}

		public override int GetHashCode() 
		{
			return Prop.GetHashCode();
		}

		public override bool IsReadOnly 
		{
			get { return Prop.CanWrite  ; }
		}
		public override void ResetValue(object component) 
		{}
		public override bool CanResetValue(object component) 
		{ return false; }
		public override bool ShouldSerializeValue(object component) 
		{ return true; }

		public override Type ComponentType 
		{
			get
			{ 
				return Prop.DeclaringType; 
			}
		}
		public override Type PropertyType 
		{
			get
			{
				return Prop.PropertyType ; 
			} 
		}
		public override object GetValue(object component) 
		{
			try
			{
				string[] PropPath = PropName.Split('.');
				object PropValue = component;
				for (int i = 0; i < PropPath.GetUpperBound(0); i++)
				{
					PropValue = PropValue.GetType().GetProperty(PropPath[i]).GetValue(PropValue, null);
				}
				return Prop.GetValue(PropValue, null); 
				
			}
			catch(System.Exception ex)
			{
				throw ex;
			}
		}
		public override void SetValue(object component, object value) 
		{
			//Correct the bug of .NEt when binding objects
			if (value == DBNull.Value )
			{
				value =GetNullValue(Prop.DeclaringType);
			}
			Prop.SetValue(component, value, null); 
			OnValueChanged(component, EventArgs.Empty);
		}
		public object GetNullValue(Type ValueType)
		{
			object Rt = null;
			if (ValueType == typeof(Guid))
			{
				Rt = Guid.Empty ;
			}
			else if (ValueType == typeof(string))
			{
				Rt = null ;
			}
			else if (ValueType == typeof(bool))
			{
				Rt = false ;
			}
			else if (ValueType == typeof(DateTime))
			{
				Rt = DateTime.MinValue  ;
			}
			else if (ValueType == typeof(int) | ValueType == typeof(Int16)| ValueType == typeof(double)| ValueType == typeof(decimal) | ValueType == typeof(Single) | ValueType == typeof(Int64))
			{
				Rt = 0;
			}
			return Rt;
		}
	}
}